VERSION 5.00
Begin VB.Form frmLotteryNumberGenerator 
   Caption         =   "Form1"
   ClientHeight    =   5445
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4530
   LinkTopic       =   "Form1"
   ScaleHeight     =   5445
   ScaleWidth      =   4530
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   495
      Left            =   2640
      TabIndex        =   3
      Top             =   1200
      Width           =   1215
   End
   Begin VB.TextBox txtPreviousNumbers 
      Height          =   3255
      Left            =   600
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   1920
      Width           =   3255
   End
   Begin VB.TextBox txtGeneratedNumbers 
      Height          =   495
      Left            =   600
      TabIndex        =   1
      Top             =   360
      Width           =   3255
   End
   Begin VB.CommandButton cmdGenerateNumbers 
      Caption         =   "&Generate Numbers"
      Height          =   495
      Left            =   600
      TabIndex        =   0
      Top             =   1200
      Width           =   1215
   End
End
Attribute VB_Name = "frmLotteryNumberGenerator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ***************************************************************************
' *                                                                         *
' * Program Title:  UK Lottery Number Generator                             *
' * Author:         Simon Cotton                                            *
' * Date:           16/07/05                                                *
' * Language:       VB6                                                     *
' * Description:    Really simple random number generator.  Excellent for   *
' *                 beginners, uses VB's Rnd function to generate numbers.  *
' *                 Also illustrates a basic sorting method to get numbers  *
' *                 in order.  Please feel free to use at will.             *
' *                                                                         *
' ***************************************************************************


Private Sub cmdGenerateNumbers_Click()
    
    Dim intResult(1 To 6) As Integer        ' Integer array to hold generated numbers
    Dim boolResultFlag As Boolean           ' Flag to ensure unique number generation
    Dim i As Integer
    Dim j As Integer
    Dim k As Integer
    Dim temp As Integer
    
    ' Intialise our array
    For i = 1 To 6
        intResult(i) = 0
    Next i
    
    ' Call randomize to ensure we get truely random results
    Randomize

    boolResultFlag = False
    
    txtGeneratedNumbers.Text = ""
    txtGeneratedNumbers.Text = "Lucky Dip: "
    
    ' Generate our first random lottery variable using 'Rnd'...
    ' Add one to result and cast as integer to ensure we get a
    ' whole number between 1 and 49
    intResult(1) = Int((49 * Rnd) + 1)
    
    ' Now repeat for the next five numbers
    For i = 2 To 6
    intResult(i) = Int((49 * Rnd) + 1)
    
        For j = 0 To 5
            If (6 - j) > i Or (6 - j) < i Then
                ' Check if generated result is unique...
                If intResult(i) = intResult(6 - j) Then
                    ' If not, enable our flag...
                    boolResultFlag = True
                End If
    
                ' And generate random numbers until we get a number which has not been generated before
                Do While (boolResultFlag)
                    intResult(i) = Int((49 * Rnd) + 1)
                    For k = 0 To 5
                        If boolResultFlag = True Then
                            If (6 - k) > i Or (6 - k) < i Then
                                If intResult(i) > intResult(6 - k) Or intResult(i) < intResult(6 - k) Then
                                    boolResultFlag = False
                                End If
                            End If
                        End If
                    Next k
                Loop
            End If
    
        Next j
    
    Next i
    
    ' Time to sort out our results by simply starting at result(6) every time we loop
    ' and working our way back through the array swapping until the least value first
    For j = 0 To 4
        For i = 0 To 4
            If intResult(6 - i) < intResult(5 - i) Then
                temp = intResult(6 - i)
                intResult(6 - i) = intResult(5 - i)
                intResult(5 - i) = temp
            End If
        Next i
    Next j
    
    ' Fire out all our results to a text box
    For i = 1 To 6
        txtGeneratedNumbers.Text = txtGeneratedNumbers.Text & intResult(i) & ", "
    Next i
    
    ' Trim the ", " off the ends using VB's Mid() and Len() functions
    txtGeneratedNumbers.Text = Mid(txtGeneratedNumbers, 1, Len(txtGeneratedNumbers) - 2)

    ' Keep tabs on all previously generated results...
    txtPreviousNumbers.Text = txtPreviousNumbers.Text & txtGeneratedNumbers.Text & vbCrLf

End Sub

Private Sub cmdExit_Click()
    
    End
    
End Sub

Private Sub Form_Load()
        
        frmLotteryNumberGenerator.Caption = "UK Lottery Number Generator"
        txtPreviousNumbers.ForeColor = vbBlue
        txtPreviousNumbers.Text = "Previously generated numbers..." & vbCrLf
        txtPreviousNumbers.Text = txtPreviousNumbers.Text & "-------------------------------------------------------------" & vbCrLf
        txtGeneratedNumbers.ForeColor = vbRed
        
End Sub
